SmartMemory
POST
/memory/search/advanced

Advanced search using Similarity Graph Traversal (SSG) algorithms.

SSG provides superior multi-hop reasoning and contextual retrieval compared to basic vector search.

Algorithms:

  • query_traversal: Best for general queries (100% test pass, 0.91 precision/recall)
  • triangulation_fulldim: Best for high precision (highest faithfulness)

Reference: Eric Lester. (2025). Novel Semantic Similarity Graph Traversal Algorithms for Semantic Retrieval Augmented Generation Systems. https://github.com/glacier-creative-git/semantic-similarity-graph-traversal-semantic-rag-research

Requires authentication and operates on user-scoped data.

Authorization

AuthorizationBearer <token>

Send Authorization: Bearer <token>. The token is either a Clerk session JWT or a SmartMemory API key (prefix sm_live_, sm_test_, or legacy sk_).

In: header

Request Body

application/json

TypeScript Definitions

Use the request body type in TypeScript.

Response Body

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://example.com/memory/search/advanced" \  -H "Content-Type: application/json" \  -d '{    "query": "string"  }'
null
{
  "detail": {
    "code": "invalid_scoped_validity",
    "message": "string",
    "retryable": false
  }
}
{
  "detail": {
    "code": "invalid_scoped_validity",
    "message": "string",
    "retryable": false
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string",
      "input": null,
      "ctx": {}
    }
  ]
}
{
  "detail": {
    "code": "invalid_scoped_validity",
    "message": "string",
    "retryable": false
  }
}